<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
<!-- qbs.qdoc -->
  <title>Generators | Qbs Manual</title>
  <link rel="stylesheet" type="text/css" href="style/offline-simple.css" />
  <script type="text/javascript">
    document.getElementsByTagName("link").item(0).setAttribute("href", "style/offline.css");
    // loading style sheet breaks anchors that were jumped to before
    // so force jumping to anchor again
    setTimeout(function() {
        var anchor = location.hash;
        // need to jump to different anchor first (e.g. none)
        location.hash = "#";
        setTimeout(function() {
            location.hash = anchor;
        }, 0);
    }, 0);
  </script>
</head>
<body>
<div class="header" id="qtdocheader">
  <div class="main">
    <div class="main-rounded">
      <div class="navigationbar">
        <table><tr>
<td ><a href="index.html">Qbs Manual</a></td><td >Generators</td></tr></table><table class="buildversion"><tr>
<td id="buildversion" width="100%" align="right">Qbs 1.15.0</td>
        </tr></table>
      </div>
    </div>
<div class="content">
<div class="line">
<div class="content mainContent">
  <link rel="prev" href="shell.html" />
  <link rel="next" href="multiplexing.html" />
<p class="naviNextPrevious headerNavi">
<a class="prevPage" href="shell.html">Using the Shell</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="multiplexing.html">Multiplexing</a>
</p><p/>
<div class="sidebar">
<div class="toc">
<h3><a name="toc">Contents</a></h3>
<ul>
<li class="level1"><a href="#generating-microsoft-visual-studio-projects">Generating Microsoft Visual Studio Projects</a></li>
<li class="level1"><a href="#generating-iar-embedded-workbench-projects">Generating IAR Embedded Workbench Projects</a></li>
<li class="level1"><a href="#keil-uvision-projects">KEIL uVision Projects</a></li>
<li class="level1"><a href="#generating-clang-compilation-databases">Generating Clang Compilation Databases</a></li>
<li class="level1"><a href="#generating-makefiles">Generating Makefiles</a></li>
<li class="level2"><a href="#targets">Targets</a></li>
<li class="level2"><a href="#pre-defined-variables">Pre-defined Variables</a></li>
<li class="level2"><a href="#spaces-in-directory-names">Spaces in Directory Names</a></li>
<li class="level2"><a href="#platform-specific-differences-in-format">Platform-specific Differences in Format</a></li>
<li class="level1"><a href="#limitations">Limitations</a></li>
</ul>
</div>
<div class="sidebar-content" id="sidebar-content"></div></div>
<h1 class="title">Generators</h1>
<span class="subtitle"></span>
<!-- $$$generators.html-description -->
<div class="descr"> <a name="details"></a>
<p>Generators are a Qbs sub-tool and set of APIs that enable arbitrary processing to be performed on the build graph. Currently, they are used to integrate Qbs with popular IDEs, such as Microsoft Visual Studio, and to generate Clang compilation databases.</p>
<a name="generating-microsoft-visual-studio-projects"></a>
<h2 id="generating-microsoft-visual-studio-projects">Generating Microsoft Visual Studio Projects</h2>
<p>To generate a project for another build system, such as Microsoft Visual Studio, use the <a href="cli-generate.html">qbs generate</a> command and specify a generator using the <a href="cli-generate.html#generate-generator">-g</a> option. For example:</p>
<pre class="cpp">

  <span class="preprocessor"># For Visual Studio</span>
  qbs generate <span class="operator">-</span>g visualstudio2015

</pre>
<p>Qbs will then generate a series of files in the current directory, based on the generator that was chosen. The resulting project files can be opened in the respective IDE and all work can be performed there.</p>
<p>The project files will expose as much information as possible to the IDE and will use Qbs to perform the actual build.</p>
<p><b>Note: </b>You cannot modify build system files and expect the changes to be reflected in Qbs. You must edit your Qbs project files and re-run <a href="cli-generate.html">qbs generate</a> in order for the changes to be reflected in your IDE.</p><a name="generating-iar-embedded-workbench-projects"></a>
<h2 id="generating-iar-embedded-workbench-projects">Generating IAR Embedded Workbench Projects</h2>
<p>To generate a project for <a href="https://www.iar.com/iar-embedded-workbench/">IAR Embedded Workbench</a>, use the <a href="cli-generate.html">qbs generate</a> command and specify a generator using the <a href="cli-generate.html#generate-generator">-g</a> option. For example:</p>
<pre class="cpp">

  <span class="preprocessor"># For IAREW v8xxxx</span>
  qbs generate <span class="operator">-</span>g iarew8 profile:<span class="operator">&lt;</span>your<span class="operator">/</span>qbs<span class="operator">/</span>profile<span class="operator">&gt;</span>
  qbs generate <span class="operator">-</span>g iarew8 <span class="operator">-</span>d <span class="operator">&lt;</span>path<span class="operator">/</span>to<span class="operator">/</span>build<span class="operator">/</span>directory<span class="operator">&gt;</span> <span class="operator">-</span>f <span class="operator">&lt;</span>path<span class="operator">/</span>to<span class="operator">/</span>qbs<span class="operator">/</span>project<span class="operator">&gt;</span> profile:<span class="operator">&lt;</span>your<span class="operator">/</span>qbs<span class="operator">/</span>profile<span class="operator">&gt;</span>

</pre>
<p><b>Note: </b>You need to specify a specific QBS profile, which is required for a generator to fetch a target architecture to generate the project.</p><p><b>Note: </b>IAR EW generator creates a native target project.</p><p>Supported IAR EW generators are listed in a table below:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Generator</th><th >IAR EW Version</th><th >Target Architecture</th></tr></thead>
<tr valign="top" class="odd"><td >iarew8</td><td >All 8.x&#x2e;y versions</td><td >ARM</td></tr>
<tr valign="top" class="even"><td >iarew7</td><td >All 7.x&#x2e;y versions</td><td >AVR, MSP430</td></tr>
<tr valign="top" class="odd"><td >iarew10</td><td >All 10.x&#x2e;y versions</td><td >8051 (aka MCS51)</td></tr>
<tr valign="top" class="even"><td >iarew3</td><td >All 3.x&#x2e;y versions</td><td >STM8</td></tr>
</table></div>
<a name="keil-uvision-projects"></a>
<h2 id="keil-uvision-projects">KEIL uVision Projects</h2>
<p>To generate a project for <a href="https://www2.keil.com/mdk5/uvision/">KEIL uVision</a>, use the <a href="cli-generate.html">qbs generate</a> command and specify a generator using the <a href="cli-generate.html#generate-generator">-g</a> option. For example:</p>
<pre class="cpp">

  <span class="preprocessor"># For KEIL UV5</span>
  qbs generate <span class="operator">-</span>g keiluv5 profile:<span class="operator">&lt;</span>your<span class="operator">/</span>qbs<span class="operator">/</span>profile<span class="operator">&gt;</span>
  qbs generate <span class="operator">-</span>g keiluv5 <span class="operator">-</span>d <span class="operator">&lt;</span>path<span class="operator">/</span>to<span class="operator">/</span>build<span class="operator">/</span>directory<span class="operator">&gt;</span> <span class="operator">-</span>f <span class="operator">&lt;</span>path<span class="operator">/</span>to<span class="operator">/</span>qbs<span class="operator">/</span>project<span class="operator">&gt;</span> profile:<span class="operator">&lt;</span>your<span class="operator">/</span>qbs<span class="operator">/</span>profile<span class="operator">&gt;</span>

</pre>
<p><b>Note: </b>You need to specify a specific QBS profile, which is required for a generator to fetch a target architecture to generate the project.</p><p><b>Note: </b>KEIL UV generator creates a native target project.</p><p>Supported KEIL UV generators are listed in a table below:</p>
<div class="table"><table class="generic">
 <thead><tr class="qt-style"><th >Generator</th><th >KEIL UV Version</th><th >Target Architecture</th></tr></thead>
<tr valign="top" class="odd"><td >keiluv5</td><td >All 5.x&#x2e;y versions</td><td >8051 (aka MCS51), ARM</td></tr>
</table></div>
<a name="generating-clang-compilation-databases"></a>
<h2 id="generating-clang-compilation-databases">Generating Clang Compilation Databases</h2>
<p>To generate a <a href="https://clang.llvm.org/docs/JSONCompilationDatabase.html">Clang compilation database (clangdb)</a>, use the following command:</p>
<pre class="cpp">

  qbs generate <span class="operator">-</span><span class="operator">-</span>generator clangdb

</pre>
<a name="generating-makefiles"></a>
<h2 id="generating-makefiles">Generating Makefiles</h2>
<p>To generate a Makefile, use the following command:</p>
<pre class="cpp">

  qbs generate <span class="operator">-</span><span class="operator">-</span>generator makefile

</pre>
<a name="targets"></a>
<h3 id="targets">Targets</h3>
<p>The generated Makefile will contain targets for all output artifacts known to Qbs.</p>
<p>In addition, the following targets are created for every product:</p>
<ul>
<li><code>&lt;product-name&gt;</code> to build the product</li>
<li><code>clean-&lt;product-name&gt;</code> to remove all files generated by the above target</li>
<li><code>install-&lt;product-name&gt;</code> to install the product's artifacts that have <code>qbs.install</code> set</li>
</ul>
<p>In the above list, the placeholder <code>&lt;product-name&gt;</code> stands for the product's name with all characters that are not ASCII letters, digits, dots or underscores replaced with underscore characters.</p>
<p>The special target <code>all</code> builds all products whose <a href="qml-qbslanguageitems-product.html#builtByDefault-prop">builtByDefault</a> property is enabled. This is the default target. It is complemented by <code>install</code> and <code>clean</code>.</p>
<p><b>Note: </b>The Makefile will not be able to build artifacts created by <a href="commands.html#javascriptcommand">JavaScriptCommands</a>, because there is no command line to run for them.</p><a name="pre-defined-variables"></a>
<h3 id="pre-defined-variables">Pre-defined Variables</h3>
<p>The build directory and the install root are set to whatever you specified when calling the generator. If you did not specify anything, Qbs' default values are used. You can override these values when invoking the <code>make</code> tool by explicitly setting the <code>BUILD_ROOT</code> and <code>INSTALL_ROOT</code> variables, respectively. For instance:</p>
<pre class="cpp">

  $ qbs generate <span class="operator">-</span>g makefile config:make modules<span class="operator">.</span>qbs<span class="operator">.</span>installRoot:<span class="operator">/</span>opt<span class="operator">/</span>mydir
  $ make <span class="operator">-</span>f make<span class="operator">/</span>Makefile                                 <span class="preprocessor"># Will install to /opt/mydir</span>
  $ make <span class="operator">-</span>f make<span class="operator">/</span>Makefile INSTALL_ROOT<span class="operator">=</span><span class="operator">/</span>opt<span class="operator">/</span>myotherdir    <span class="preprocessor"># Will install to /opt/myotherdir</span>

</pre>
<a name="spaces-in-directory-names"></a>
<h3 id="spaces-in-directory-names">Spaces in Directory Names</h3>
<p>Due to the difficulties involved in making this work correctly, Qbs will refuse to generate a Makefile if the source, build or install root directories contain spaces. It will try to handle spaces in file names of output artifacts, though.</p>
<a name="platform-specific-differences-in-format"></a>
<h3 id="platform-specific-differences-in-format">Platform-specific Differences in Format</h3>
<p>Qbs assumes that the Makefile will be invoked on the current host platform, so that platform's tools will be used for copying and removing files, and path separators will be converted to backslashes on Windows. When dealing with spaces in artifact names, on Unix-like systems compatibility with GNU make is assumed with regards to quoting.</p>
<a name="limitations"></a>
<h2 id="limitations">Limitations</h2>
<p>Due to the high flexibility of the Qbs project format and build engine, some projects may be too complex to produce an equivalent project file for another build system.</p>
<p>This list of limitations aims to be as small as possible, but one of the most notable (at least for the Microsoft Visual Studio generator) is that certain properties must contain the same value across all build configurations. For example, the following is not allowed:</p>
<pre class="cpp">

  Product {
      <span class="comment">// ERROR: 'name' property cannot have different values based on the configuration</span>
      name: qbs<span class="operator">.</span>configuration <span class="operator">=</span><span class="operator">=</span><span class="operator">=</span> <span class="string">&quot;debug&quot;</span>
          <span class="operator">?</span> <span class="string">&quot;MyProduct_debug&quot;</span>
          : <span class="string">&quot;MyProduct&quot;</span>
  }

</pre>
<p><b>Note: </b>This limitation only applies when property values are varied on the configuration name. For example, the following is OK (as long as the value of xyz itself does not vary across configurations):</p><pre class="cpp">

  Product {
      <span class="comment">// OK</span>
      property bool isDebug: <span class="operator">&lt;</span>some value<span class="operator">&gt;</span>
      name: isDebug <span class="operator">?</span> <span class="string">&quot;MyProduct_debug&quot;</span> : <span class="string">&quot;MyProduct&quot;</span>
  }

</pre>
<p>The properties to which the limitation applies includes but is not limited to:</p>
<ul>
<li><a href="qml-qbslanguageitems-product.html#name-prop">Product.name</a></li>
<li><a href="qml-qbsmodules-bundle.html#isBundle-prop">bundle.isBundle</a></li>
</ul>
<p>If a simple workaround is possible in a particular case (for example, varying <a href="qml-qbslanguageitems-product.html#targetName-prop">Product.targetName</a> across configuration instead of <a href="qml-qbslanguageitems-product.html#name-prop">Product.name</a>, the generator will typically suggest it in the error message.</p>
</div>
<!-- @@@generators.html -->
<p class="naviNextPrevious footerNavi">
<a class="prevPage" href="shell.html">Using the Shell</a>
<span class="naviSeparator">  &#9702;  </span>
<a class="nextPage" href="multiplexing.html">Multiplexing</a>
</p>
        </div>
       </div>
   </div>
   </div>
</div>
<div class="footer">
   <p>
   <acronym title="Copyright">&copy;</acronym> 2020 The Qt Company Ltd.
   Documentation contributions included herein are the copyrights of
   their respective owners.<br/>    The documentation provided herein is licensed under the terms of the    <a href="http://www.gnu.org/licenses/fdl.html">GNU Free Documentation    License version 1.3</a> as published by the Free Software Foundation.<br/>    Qt and respective logos are trademarks of The Qt Company Ltd.     in Finland and/or other countries worldwide. All other trademarks are property
   of their respective owners. </p>
</div>
</body>
</html>
